POJ 2387 Til the Cows Come Home (最短路+Dijkstra)

Til the Cows Come Home
Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 29550   Accepted: 9935

Description

Bessie is out in the field and wants to get back to the barn to get as much sleep as possible before Farmer John wakes her for the morning milking. Bessie needs her beauty sleep, so she wants to get back as quickly as possible.

Farmer John's field has N (2 <= N <= 1000) landmarks in it, uniquely numbered 1..N. Landmark 1 is the barn; the apple tree grove in which Bessie stands all day is landmark N. Cows travel in the field using T (1 <= T <= 2000) bidirectional cow-trails of various lengths between the landmarks. Bessie is not confident of her navigation ability, so she always stays on a trail from its start to its end once she starts it.

Given the trails between the landmarks, determine the minimum distance Bessie must walk to get back to the barn. It is guaranteed that some such route exists.

Input

* Line 1: Two integers: T and N

* Lines 2..T+1: Each line describes a trail as three space-separated integers. The first two integers are the landmarks between which the trail travels. The third integer is the length of the trail, range 1..100.

Output

* Line 1: A single integer, the minimum distance that Bessie must travel to get from landmark N to landmark 1.

Sample Input

5 5
1 2 20
2 3 30
3 4 20
4 5 20
1 5 100

Sample Output

90

Hint

INPUT DETAILS:

There are five landmarks.

OUTPUT DETAILS:

Bessie can get home by following trails 4, 3, 2, and 1.

Source

USACO 2004 November

题目大意:有N个点,给出从a点到b点的距离,当然a和b是互相能够抵达的,问从1到n的最短距离

解题思路:模版题,这题要注意的是有重边,dijkstra的算法须要考虑下,bellman-ford和spfa能够忽略这个问题

代码:实验证明这道题的数据临界值是1000,我开1000的dis[0]没用,就挂了。。。无语。

#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cstring>
using namespace std;
#define M 1005
#define INF  9999999
#define min(a,b) (a<b?a:b)
int map[M][M],dis[M];
int m,n;
void Dijkstra()
{
    bool v[M];
    int Min=INF,s,i,j;
    memset(v,0,sizeof v);
    map[0][1]=map[1][0]=0;  //由于我要套模板啦,所以还是从0開始。
    for(i=0;i<=n;i++) dis[i]=(i==0?0:INF);  //白书就这么简单,不知道黄书怎么那么难。。。是等级不同吗
    for(i=0;i<=n;i++)
    {
     Min=INF;
     for(j=0;j<=n;j++)
     if(!v[j] && dis[j]<Min)
     {
     Min=dis[j];s=j;
     }
     v[s]=1;
     for(j=0;j<=n;j++)
     dis[j]=min(dis[j],dis[s]+map[s][j]);

    }
    printf("%d
",dis[n]);
}
int main()
{
    int i,j;
    int a,b,z;
    scanf("%d%d",&m,&n);
    for(i=0;i<=n;i++)
    for(j=0;j<=n;j++)
    map[i][j]=(i==j?0:INF);
    while(m--)
    {
        scanf("%d%d%d",&a,&b,&z);
        map[a][b]=map[b][a]=min(map[a][b],z);
    }
    Dijkstra();
    return 0;
}

原文地址:https://www.cnblogs.com/zfyouxi/p/4067296.html